﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;

public partial class dwb : System.Web.UI.Page
{
    public string SQLHintObj = string.Empty;
    ASBExt.WebServiceExt asbEx = new ASBExt.WebServiceExt();
    ASB.WebService asbWeb = new ASB.WebService();
    Util.Util utils = new Util.Util();
    public string nodeAccessToken = string.Empty;
    public string userResps = string.Empty;
    public string restdllPath = string.Empty;
    public string ArmRestDllPath = string.Empty;
    public string nodeAPI = string.Empty;
    public string userroles = string.Empty;
    public string redisutl = string.Empty;
    public string sid = string.Empty;
    public string utl = string.Empty;//Session["utl"]
    public string hasPageBuildAccess = string.Empty;
    public string nodeApi = string.Empty;
    public int alertsTimeout = 3000;
    public int errorTimeout = 0;
    public bool errorEnable = false;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (HttpContext.Current.Session["Project"] == null || Convert.ToString(HttpContext.Current.Session["Project"]) == string.Empty)
        {
            SessExpires();
            return;
        }
        SQLHintObj = asbWeb.getSQLHintObj();
        try
        {
            alertsTimeout = HttpContext.Current.Session["AxAlertTimeout"] != null ? (Convert.ToInt32(HttpContext.Current.Session["AxAlertTimeout"]) * 1000) : 3000;
        }
        catch (Exception ex)
        {
            alertsTimeout = 3000;
        }
        try
        {
            var session = HttpContext.Current.Session;
            if (session["AxErrorMsg"] != null)
            {
                errorEnable = Convert.ToBoolean(session["AxErrorMsg"]);
                errorTimeout = session["AxErrorMsgTimeout"] != null ? (Convert.ToInt32(session["AxErrorMsgTimeout"]) * 1000) : 0;
            }
            else
            {
                errorTimeout = 0;
                errorEnable = false;
            }
        }
        catch (Exception ex)
        {
            errorTimeout = 0;
            errorEnable = false;
        }

        if (HttpContext.Current.Session["nodeAccessToken"] != null && HttpContext.Current.Session["nodeAccessToken"].ToString() != "")
            nodeAccessToken = HttpContext.Current.Session["nodeAccessToken"].ToString();
        if (HttpContext.Current.Session["AxResponsibilities"] != null && HttpContext.Current.Session["AxResponsibilities"].ToString() != "")
            userResps = HttpContext.Current.Session["AxResponsibilities"].ToString();
        if (ConfigurationManager.AppSettings["RestDllPath"] != null && ConfigurationManager.AppSettings["RestDllPath"].ToString() != "")
            restdllPath = ConfigurationManager.AppSettings["RestDllPath"].ToString();
        if (ConfigurationManager.AppSettings["NodeAPI"] != null && ConfigurationManager.AppSettings["NodeAPI"].ToString() != "")
            nodeAPI = ConfigurationManager.AppSettings["NodeAPI"].ToString();
        if (HttpContext.Current.Session["AxRole"] != null && HttpContext.Current.Session["AxRole"].ToString() != "")
            userroles = HttpContext.Current.Session["AxRole"].ToString();
        if (ConfigurationManager.AppSettings["redisIP"] != null && ConfigurationManager.AppSettings["redisIP"].ToString() != "")
            redisutl = ConfigurationManager.AppSettings["redisIP"].ToString();
        if (HttpContext.Current.Session["nsessionid"] != null && HttpContext.Current.Session["nsessionid"].ToString() != "")
            sid = HttpContext.Current.Session["nsessionid"].ToString();
        if (HttpContext.Current.Session["utl"] != null && HttpContext.Current.Session["utl"].ToString() != "")
            utl = HttpContext.Current.Session["utl"].ToString();//Session["utl"]
        if (HttpContext.Current.Session["hasPageBuildAccess"] != null && HttpContext.Current.Session["hasPageBuildAccess"].ToString() != "")
            hasPageBuildAccess = HttpContext.Current.Session["hasPageBuildAccess"].ToString();
        if (ConfigurationManager.AppSettings["NodeAPI"] != null && ConfigurationManager.AppSettings["NodeAPI"].ToString() != "")
            nodeApi = ConfigurationManager.AppSettings["NodeAPI"].ToString();
        if (Session["ARM_Scripts_URL"] != null)
            ArmRestDllPath = Session["ARM_Scripts_URL"].ToString();
    }
    private void SessExpires()
    {
        string url = Convert.ToString(HttpContext.Current.Application["SessExpiryPath"]);
        Response.Write("<script>" + Constants.vbCrLf);
        Response.Write("parent.parent.location.href='" + url + "';");
        Response.Write(Constants.vbCrLf + "</script>");
    }


    [WebMethod]
    public static Object getIvDefParamsNColumns(string dwbIvDefName, string transid)
    {
        try
        {
            LogFile.Log logobj = new LogFile.Log();
            Util.Util util = new Util.Util();
            ASBExt.WebServiceExt asbExt = new ASBExt.WebServiceExt();

            string result = string.Empty;
            string sqlQuery = string.Empty;
            string errorLog = logobj.CreateLog("Call Get Iview Def ParamsNColumns", HttpContext.Current.Session["nsessionid"].ToString(), "CallGetIviewDefParamsNColumns", "new", "true");
            string inputXML = "<sqlresultset axpapp='" + HttpContext.Current.Session["project"].ToString() + "' sessionid='" + HttpContext.Current.Session["nsessionid"].ToString() + "' trace='" + errorLog + "' appsessionkey='" + HttpContext.Current.Session["AppSessionKey"].ToString() + "' username='" + HttpContext.Current.Session["username"].ToString() + "' ><sql>";

            if (transid == "ad_ip")
                sqlQuery = "select dwb_iviewparamsid as recordid, 'Parameters' as para, pname, pcaption,'tad_ip' ptransid, dwb_iviewparamsid, isqueryparam, datatype from dwb_iviewparams as a1 where iname = '" + dwbIvDefName + "' order by pord";
            else if (transid == "ad_ic")
                sqlQuery = "select dwb_iviewcolsid as recordid, 'Columns' as para, f_name, f_caption, column_width, hidden, 'tad_ic' ptransid, dwb_iviewcolsid, isquerycol,COALESCE(a2.dwb_IVIEWHYPLINKid,0) as hyperrecid, COALESCE(a3.dwb_iviewcformatid,0) as cformatrecid, a4.groupid mergeid, a4.groupname mergename from dwb_iviewcols as a1 left join dwb_IVIEWHYPLINK a2 on a1.iname = a2.iname and a1.f_name = a2.hypsource left join dwb_iviewcformat a3 on a1.iname = a3.iname and a1.f_name = a3.name left join dwb_iviewcolsmerge a4 on a1.iname = a4.iname and a1.f_name = a4.colname where a1.iname = '" + dwbIvDefName + "' order by a1.ordno";
            else if (transid == "ad_sc")
                sqlQuery = "select dwb_iviewscriptsid as recordid, 'Scripts' as para, name as pname, caption as pcaption,'tad_sc' ptransid, dwb_iviewscriptsid, event, 'f' as isqueryparam from dwb_iviewscripts as a1 where iname = '" + dwbIvDefName + "' order by caption";
            else if (transid == "temps")
            {
                sqlQuery = "select f_name from dwb_iviewcols where iname = '" + dwbIvDefName + "' order by ordno";
            }

            sqlQuery = util.CheckSpecialChars(sqlQuery);
            inputXML += sqlQuery + " </sql>" + HttpContext.Current.Session["axApps"].ToString() + HttpContext.Current.Application["axProps"].ToString() + HttpContext.Current.Session["axGlobalVars"].ToString() + HttpContext.Current.Session["axUserVars"].ToString() + "</sqlresultset>";
            result = asbExt.CallGetChoiceWS("", inputXML);

            string errMsg = util.ParseXmlErrorNode(result);
            if (errMsg != string.Empty)
            {
                return new { status = "error", transid = transid, result = errMsg };
            }
            else
            {
                try
                {
                    XmlDocument doc = new XmlDocument();

                    doc.LoadXml(result.ToString());
                    var json = JsonConvert.SerializeXmlNode(doc);
                    return new { status = "success", transid = transid, result = json };
                }
                catch (Exception ex)
                {
                    return new { status = "failure", transid = transid, result = Constants.CUSTOMERROR };
                }
            }

        }
        catch (Exception ex)
        {
            return new { status = "failure", transid = transid, result = Constants.CUSTOMERROR };
        }

    }

    [WebMethod]
    public static Object delIvDefParamsNColumns(string recordid, string transid)
    {
        try
        {
            LogFile.Log logobj = new LogFile.Log();
            Util.Util util = new Util.Util();
            ASBExt.WebServiceExt asbExt = new ASBExt.WebServiceExt();

            string result = string.Empty;
            string sqlQuery = string.Empty;
            string errorLog = logobj.CreateLog("Call Delete Iview Def ParamsNColumns", HttpContext.Current.Session["nsessionid"].ToString(), "CallDelIvDefParamsNColumns", "new", "true");
            string inputXML = "<sqlresultset axpapp='" + HttpContext.Current.Session["project"].ToString() + "' sessionid='" + HttpContext.Current.Session["nsessionid"].ToString() + "' trace='" + errorLog + "' appsessionkey='" + HttpContext.Current.Session["AppSessionKey"].ToString() + "' username='" + HttpContext.Current.Session["username"].ToString() + "' ><sql>";
            if (transid == "ad_ic")
                sqlQuery = "delete from dwb_iviewcols where dwb_iviewcolsid = " + recordid;
            else if (transid == "ad_ip")
                sqlQuery = "delete from dwb_iviewparams where dwb_iviewparamsid = " + recordid;
            else if (transid == "ad_sc")
                sqlQuery = "delete from dwb_iviewscripts where dwb_iviewscriptsid = " + recordid;

            sqlQuery = util.CheckSpecialChars(sqlQuery);
            inputXML += sqlQuery + " </sql>" + HttpContext.Current.Session["axApps"].ToString() + HttpContext.Current.Application["axProps"].ToString() + HttpContext.Current.Session["axGlobalVars"].ToString() + HttpContext.Current.Session["axUserVars"].ToString() + "</sqlresultset>";
            result = asbExt.CallGetChoiceWS("", inputXML);

            string errMsg = util.ParseXmlErrorNode(result);
            if (errMsg != string.Empty)
            {
                return new { status = "error", transid = transid, recordid = recordid, result = errMsg };
            }
            else
            {
                if (result == "done")
                    return new { status = "success", transid = transid, recordid = recordid, result = result };
                else
                    return new { status = "failure", transid = transid, recordid = recordid, result = "" };
            }
        }
        catch (Exception ex)
        {
            return new { status = "failure", transid = transid, recordid = recordid, result = Constants.CUSTOMERROR };
        }
    }
}
